// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.
nz-card.ryax-action-run-card(
  *ngIf="(currentActionRun$ | async); let actionRun",
  [nzTitle]="titleTemplate", [nzExtra]="extraTemplate", [nzBodyStyle]="{ padding: 0, display: 'flex', 'align-items': 'center' }")
  nz-collapse(
    [nzGhost]="true", nz-row)
    nz-collapse-panel([nzDisabled]="true", [nzShowArrow]="false", [nzActive]="showDetails")
      .ryax-execution-details
        section
          h4.error(*ngIf="actionRun.errorMessage") ERROR
          div.error(*ngIf="actionRun.errorMessage")
            p {{ actionRun.errorMessage }}
          h4 INPUTS
          ryax-module-execution-ios([data]="actionRun.inputs")
          h4 OUTPUTS
          ryax-module-execution-ios([data]="actionRun.outputs")
      div(*ngIf="actionRun.attempts.length > 1").ryax-retries
        h3 RETRIES
        nz-pagination(
          [nzPageIndex]="((currentAttemptIndex$ | async) ?? 0) + 1",
          nzPageSize=1,
          [nzTotal]="actionRun.attempts.length",
          nzSimple=true,
          (nzPageIndexChange)="selectAttempt($event)"
        )
      .ryax-execution-details
        section(*ngIf="currentAttempt$ | async as currentAttempt")
          h4.error(*ngIf="currentAttempt.errorMessage") ERROR
          div.error(*ngIf="currentAttempt.errorMessage")
            p {{ currentAttempt.errorMessage }}

          h4 TIME
          div(*ngIf="!(this.index == 0)")
            p
              label Submit
              | {{ currentAttempt.submittedDate | dateTimeToFormat : dateFormat }}
            p
              Label Waiting
              | {{ getWaitingTime(currentAttempt) | durationToFormat : 'mm\'m\' ss.SSS\'s\'' }}
          div
            p
              label Start
              | {{ currentAttempt.startedDate | dateTimeToFormat : dateFormat }}
            p
              Label Running
              | {{ getExecutionTime(currentAttempt) | durationToFormat : 'mm\'m\' ss.SSS\'s\'' }}
          div
            p
              label End
              | {{ currentAttempt.endedDate | dateTimeToFormat : dateFormat }}
            p
              Label Total
              | {{ getTotalTime(currentAttempt) | durationToFormat : 'mm\'m\' ss.SSS\'s\'' }}
      nz-collapse(*ngIf="!(this.index == 0)", [nzGhost]="true")
        nz-collapse-panel.ryax-logs([nzHeader]="logsHeader", (nzActiveChange)="getLogsTrigger()", [nzActive]="showLogs$ | async")
          .ryax-log-refresh
            ryax-console-display([textContent]="logsValue() | async", [refreshButton]="true", (refreshEmitter)="refreshLogs()", [loading]="isLoadingLogs() | async")

ng-template(#logsHeader)
  .ryax-log-collapse-header
    h4 {{!(showLogs$ | async) ? "SEE LOGS" : "LOGS"}}



ng-template(#titleTemplate)
  .ryax-card-content(
    *ngIf="(currentActionRun$ | async); let actionRun",
  )
    .ryax-module-icon
      img([src]="'/api/studio/static/logo/' + actionRun.definitionId")
    div
      p.ryax-card-title {{ actionRun.name }}
      span.ryax-card-version {{ actionRun.version }}
      p.ryax-card-description {{ actionRun.description }}

ng-template(#extraTemplate)
  a.ryax-details((click)="toggleDetails()") {{ showDetails ? 'Hide' : 'View' }} details
